;================================
;          ZX-Assembler-2 
;      by Artic Computing LTD
;================================

ORG 50AA

@Seed=4032			;Puzzle pointer
@Bank2=2200			;Bank2 pointer
@LastK=4025			;Last key sysvar
@DFile=400C			;DFile

;================================
;Load puzzle
;================================
@UDGOn
	LD A,21
@SetI
	LD I,A
	RET
@UDGOff
	LD A,1E
	JR SetI
;================================
;Load puzzle
;================================
@Puzzle
	LD HL,(SEED)		;Puzzle pointer
	LD DE,Bank2		;Font bank2
	LD BC,0200		;512 bytes to move
	LDIR			;Move puzzle to Bank2
	RET
;================================
;Invert puzzle
;================================
@Invert
	LD HL,Bank2
@InvLoop
	LD A,(HL)
	CPL
	LD (HL),A
	INC HL
	LD A,H
	CP 24
	JR NZ InvLoop
;================================
;Wait for key to be released
;================================
@Release
	LD A,(LastK)		;Check LastK sysvar
	CP FF			;Key down?
	JR NZ Release		;Yes, wait for key release
	LD BC,0000		;RET 0
	RET
;================================
;Wait for keypress
;================================
@Press
	LD A,(LastK)		;Check LastK sysvar
	CP FF			;Key down?
	JR Z Press		;No, wait for keypress
	LD BC,0000		;RET 0
	RET
;================================
;Set up menu
;================================
@Setup
	LD HL,2200		;Menu list
	LD DE,5012		;Store list at 20498
	LD BC,008C		;140 bytes to move
	LDIR			;Move menu
	RET
;================================
;Print menu
;================================
@Menu
	LD HL,(DFILE)
	LD BC,+136		;Offset into DFile
	ADD HL,BC
	LD DE,5012		;Menu list
	LD B,+14		;14 menu items
@Loop1
	LD C,+10		;10 bytes/menu item
@Loop2
	LD A,(DE)		;Menu character
	LD (HL),A		;Copy to DFile
	INC DE			;Next menu character
	INC HL			;Next DFile location
	DEC C			;Decrease counter
	JR NZ Loop2		;Loop till menu item printed
	LD A,B			;Save list counter
	LD BC,+23		;Offset to next DFile row
	ADD HL,BC		;Next DFile row
	LD B,A			;Restore list counter
	DJNZ Loop1		;Print next menu item
	RET